// Copyright Peter Porzsolt

var doc = app.activeDocument;
var layer = doc.layers[0];

var unit = 2.8346; // unit default is mm, change it to 0.0394 for inch

var boxHeight=25*unit;
var boxWidth=25*unit;
var getStep=prompt("How much % between colors?", "5");
var step=Number(getStep)
var charSize=7; //in points
var space=3*unit;






var getCMYK = prompt("CMYK Color separated by comma", "26,90,10,10");
var splitCMYK = getCMYK.split(",");
var c=Number(splitCMYK[0]);
var m=Number(splitCMYK[1]);
var y=Number(splitCMYK[2]);
var k=Number(splitCMYK[3]);
var cx=c;
var mx=m;
var yx=y;
var kx=k;
var row=3;
var id=1;
var colors= [0-(step*1),0,step*1];
var arrayLength = colors.length;
var hPos=space;
var hDist=boxWidth+space;
var vDist=boxWidth+space;
var line=1;
var vDistT=vDist;
var counter=1;
var row=1;
var gr=1
var boxArray = [];




for ( var ik = 0; ik < arrayLength; ik++ ){
	kx=k+colors[ik];
	if(kx<0)  {kx=0;}
	if(kx>100){kx=100;}
	
	for ( var iy = 0; iy < arrayLength; iy++ ){
		yx=y+colors[iy];
		if(yx<0)  {yx=0;}
		if(yx>100){yx=100;}
		
		for ( var im = 0; im < arrayLength; im++ ){
			mx=m+colors[im];
			if(mx<0)  {mx=0;}
			if(mx>100){mx=100;}

			for ( var ic = 0; ic < arrayLength; ic++ ){
				cx=c+colors[ic];
				if(cx<0)  {cx=0;}
				if(cx>100){cx=100;}
				
				if (counter==4){ counter=1; row++}
				if (row==4){row=1;}
				if (id==4) {id=1;hPos=hPos+space;}
				if (gr==10){gr=1;}
				
				
				    var vPos=vDist*row;
					hPos=hPos+hDist
					
					if (row==2 && id==1){hPos=hPos-(hDist*3)-space}
					if (row==3 && id==1){hPos=hPos-(hDist*3)-space}
					
                  var mix=cx+""+mx+""+yx+""+kx;
				  
				if (check(boxArray,mix)){
					//if duplicate draw white box
				var rect = layer.pathItems.rectangle(-vPos, hPos, boxWidth, boxHeight);
				colorBox(0,0,0,0);
				var textRef = doc.textFrames.add()
				textBox(hPos,id,line,counter,row,gr,0);
					
				}else{
				  //draw new box if color was not used before
				var rect = layer.pathItems.rectangle(-vPos, hPos, boxWidth, boxHeight);
				colorBox(cx,mx,yx,kx);
				var textRef = doc.textFrames.add()
				textBox(hPos,id,line,counter,row,gr,100);
				boxArray.push(mix);
				}
				counter++
				id++
				
			}
		}	
	gr++	
	}

}

function colorBox(cx,mx,yx,kx){
	rect.fillColor = makeColorCMYK(cx,mx,yx,kx);
	if(cx==c && mx==m && yx==y && kx==k)
		{rect.stroked = true;
		 rect.strokeWidth=2;
		}else{rect.stroked = false;}

}

function textBox(hPos,id,line,counter,row,xxx,tcol){
	textRef.top = -vPos-boxHeight+charSize*0.6;
	textRef.left = hPos;
	textRef.textRange.characterAttributes.size = charSize;
	textRef.textRange.characterAttributes.fillColor=makeColorCMYK(0,0,0,tcol);
	textRef.contents ="C"+cx+"M"+mx+"Y"+yx+"K"+kx/*+" id"+id+" row"+row+" gr"+gr*/;
	
	return textRef;
}


function makeColorCMYK(c,m,y,k){
    var ink = new CMYKColor();
    ink.cyan   = c;
    ink.magenta = m;
    ink.yellow  = y;
    ink.black  = k;
    return ink;
}

function check(myArray, name) {
    for (i = 0; i < myArray.length; i++) {
        if (myArray[i] == name) {
            return true;
        } 
    }
}

